﻿// <copyright file="MobileServiceFactory.cs" company="ANUJ Technologies Inc.">
// Copyright (c) 10-06-2011 All Right Reserved
// </copyright>
// <author>Anuj Varma, www.anujvarma.com</author>
// <date>10-06-2011</date>
// <summary>Class representing a MobileServiceFactory.cs entity.</summary>

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Services_Architecture.ServicesByFeature;
using Services_Architecture.ServicesByPlatform;

namespace Services_Architecture.ServiceFactory
{
    public class SqlServerServiceFactory: IServiceFactory
    {
        public SqlServerServiceFactory()
        {
            FillServiceDictionary();
        }

        private IDictionary<string, object> allservices = new Dictionary<string, object>();

        public T GetService<T>()
        {
            object service = new object();
            T returnedService = default(T);
            string serviceName = typeof(T).Name;
            if (allservices.TryGetValue(serviceName, out service))
            {
                returnedService = (T) service;
            }

            return returnedService;

        }

        protected void FillServiceDictionary()
        {
            allservices.Add("IAccountService", new SqlServerAccountService());
            allservices.Add("ISecurityService", new SqlServerSecurityService());
        }
    }
}
