﻿// <copyright file="AccountService.cs" company="ANUJ Technologies Inc.">
// Copyright (c) 10-06-2011 All Right Reserved
// </copyright>
// <author>Anuj Varma, www.anujvarma.com</author>
// <date>10-06-2011</date>
// <summary>Class representing a AccountService.cs entity.</summary>

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Services_Architecture.ServicesByFeature
{
    public abstract class AccountService : IAccountService
    {
        public virtual void CreateAccount()
        {

            //  common code - example - Initialize
            Console.WriteLine("Account Service: Common Initialization Code");

            // Platform specific code
            SomePlatformSpecificOperation(); 

            // common code again - example - cleanup()...
            Console.WriteLine("Account Service: Common Cleanup Code");

        }

        protected virtual void SomePlatformSpecificOperation()
        {
            Console.WriteLine("Some BASE operation that is common to both ORACLE and SQLServer. This can be over-riddent in the child classes for PLATFORM speficic functionality");
        }
    }
}
